import React from 'react';
import Button from '../../Button';
import Shortcuts from './shortcuts';
import { isArray } from '../../_util/is';
import Link from '../../Link';
export default function Footer(props) {
    var showTime = props.showTime, prefixCls = props.prefixCls, DATEPICKER_LOCALE = props.DATEPICKER_LOCALE, disabled = props.disabled, onClickConfirmBtn = props.onClickConfirmBtn, onClickSelectTimeBtn = props.onClickSelectTimeBtn, isTimePanel = props.isTimePanel, onSelectNow = props.onSelectNow, showNowBtn = props.showNowBtn, shortcuts = props.shortcuts, onMouseEnterShortcut = props.onMouseEnterShortcut, onMouseLeaveShortcut = props.onMouseLeaveShortcut, onSelectShortcut = props.onSelectShortcut, extra = props.extra, mode = props.mode, shortcutsPlacementLeft = props.shortcutsPlacementLeft;
    var hasShortcuts = isArray(shortcuts) && shortcuts.length > 0;
    var shouldShowNowBtn = showNowBtn && showTime && !hasShortcuts;
    var shouldShouldShortcuts = shouldShowNowBtn || (hasShortcuts && !shortcutsPlacementLeft);
    return (React.createElement("div", { className: prefixCls + "-footer" },
        extra && React.createElement("div", { className: prefixCls + "-footer-extra-wrapper" }, extra),
        !showTime && showNowBtn && mode === 'date' && (React.createElement("div", { className: prefixCls + "-footer-now-wrapper" },
            React.createElement(Link, { onClick: onSelectNow }, DATEPICKER_LOCALE.today))),
        shouldShouldShortcuts || showTime ? (React.createElement("div", { className: prefixCls + "-footer-btn-wrapper" },
            !shortcutsPlacementLeft ? (React.createElement(Shortcuts, { shortcuts: shortcuts, prefixCls: prefixCls, onSelectNow: onSelectNow, nowText: DATEPICKER_LOCALE.now, showNowBtn: showNowBtn, onMouseEnterShortcut: onMouseEnterShortcut, onMouseLeaveShortcut: onMouseLeaveShortcut, onSelectShortcut: onSelectShortcut, showTime: showTime })) : (React.createElement("div", null)),
            showTime && (React.createElement(React.Fragment, null,
                React.createElement(Button, { type: "text", size: "mini", onClick: onClickSelectTimeBtn, className: isTimePanel ? prefixCls + "-btn-select-date" : prefixCls + "-btn-select-time" }, isTimePanel ? DATEPICKER_LOCALE.selectDate : DATEPICKER_LOCALE.selectTime),
                React.createElement(Button, { className: prefixCls + "-btn-confirm", type: "primary", size: "mini", disabled: disabled, onClick: onClickConfirmBtn }, DATEPICKER_LOCALE.ok))))) : null));
}
