import 'dayjs/locale/fr';
var Calendar = {
    formatYear: 'YYYY',
    formatMonth: 'MM/YYYY',
    monthBeforeYear: true,
    today: "Aujourd'hui",
    view: {
        month: 'Mois',
        year: 'Année',
        week: 'Semaine',
        day: 'Date',
    },
    month: {
        long: {
            January: 'Janvier',
            February: 'Février',
            March: 'Mars',
            April: 'Avril',
            May: 'Mai',
            June: 'Juin',
            July: 'Juillet',
            August: 'Août',
            September: 'Septembre',
            October: 'Octobre',
            November: 'Novembre',
            December: 'Décembre',
        },
        short: {
            January: 'Jan',
            February: 'Fév',
            March: 'Mar',
            April: 'Avr',
            May: 'Mai',
            June: 'Jun',
            July: 'Jul',
            August: 'Aoû',
            September: 'Sep',
            October: 'Oct',
            November: 'Nov',
            December: 'Déc',
        },
    },
    week: {
        long: {
            self: 'Week',
            monday: 'Lundi',
            tuesday: 'Mardi',
            wednesday: 'Mercredi',
            thursday: 'Jeudi',
            friday: 'Vendredi',
            saturday: 'Samedi',
            sunday: 'Dimanche',
        },
        short: {
            self: 'Week',
            monday: 'Lun',
            tuesday: 'Mar',
            wednesday: 'Mer',
            thursday: 'Jeu',
            friday: 'Ven',
            saturday: 'Sam',
            sunday: 'Dim',
        },
    },
};
export default {
    locale: 'fr-FR',
    dayjsLocale: 'fr',
    Calendar: Calendar,
    DatePicker: {
        Calendar: Calendar,
        placeholder: {
            date: 'Sélectionner une date',
            week: 'Sélectionner une semaine',
            month: 'Sélectionner un mois',
            year: 'Sélectionner une année',
            quarter: 'Sélectionner un trimestre',
        },
        placeholders: {
            date: ['Date de début', 'Date de fin'],
            week: ['Semaine de début', 'Semaine de fin'],
            month: ['Mois de début', 'Mois de fin'],
            year: ['Année de début', 'Année de fin'],
            quarter: ['Trimestre de début', 'Trimestre de fin'],
        },
        selectTime: "Sélectionner l'heure",
        selectDate: 'Sélectionner la date',
        today: "Aujourd'hui",
        now: 'Maintenant',
        ok: 'OK',
    },
    Drawer: {
        okText: 'OK',
        cancelText: 'Annuler',
    },
    Empty: {
        noData: 'Aucune donnée',
    },
    Modal: {
        okText: 'OK',
        cancelText: 'Annuler',
    },
    Pagination: {
        goto: 'Aller à',
        page: 'Page',
        countPerPage: '/ page',
        total: 'Total {0}',
        prev: 'page précédente',
        next: 'page suivante',
        currentPage: 'page {0}',
        prevSomePages: 'Page {0} précédente',
        nextSomePages: 'Page {0} suivante',
        pageSize: 'numéro de page',
    },
    Popconfirm: {
        okText: 'OK',
        cancelText: 'Annuler',
    },
    Table: {
        okText: 'OK',
        resetText: 'Réinitialiser',
        sortAscend: 'Trier par ordre croissant',
        sortDescend: 'Trier par ordre décroissant',
        cancelSort: 'Annuler le tri',
    },
    TimePicker: {
        ok: 'OK',
        placeholder: 'Sélectionner une heure',
        placeholders: ['Heure de début', 'Heure de fin'],
        now: 'Maintenant',
    },
    Progress: {
        success: 'Finir',
        error: 'Échouer',
    },
    Upload: {
        start: 'Démarrer',
        cancel: 'Annuler',
        delete: 'Supprimer',
        reupload: 'Cliquez pour réessayer',
        upload: 'Cliquez pour télécharger',
        preview: 'Aperçu',
        drag: 'Cliquez ou faites glisser les fichiers à télécharger ici',
        dragHover: 'Libérez le fichier et commencez à télécharger',
        error: 'le téléchargement a échoué',
    },
    Typography: {
        copy: 'Copier',
        copied: 'Copie effectuée',
        edit: 'Éditer',
        fold: 'Plier',
        unfold: 'Étendre',
    },
    Transfer: {
        resetText: 'Réinitialiser',
    },
    ImagePreview: {
        fullScreen: 'Plein écran',
        rotateRight: 'Tourner à droite',
        rotateLeft: 'Tourner vers la gauche',
        zoomIn: 'Agrandir',
        zoomOut: 'Dézoomer',
        originalSize: 'Format original',
    },
};
