import 'dayjs/locale/ru';
var Calendar = {
    formatYear: 'YYYY',
    formatMonth: 'MM/YYYY',
    monthBeforeYear: true,
    today: 'Cегодня',
    view: {
        month: 'месяц',
        year: 'год',
        week: 'Неделя',
        day: 'день',
    },
    month: {
        long: {
            January: 'января',
            February: 'февраля',
            March: 'марта',
            April: 'апреля',
            May: 'мая',
            June: 'июня',
            July: 'июля',
            August: 'августа',
            September: 'сентября',
            October: 'октября',
            November: 'ноября',
            December: 'декабря',
        },
        short: {
            January: 'янв',
            February: 'фев',
            March: 'мар',
            April: 'апр',
            May: 'май',
            June: 'июн',
            July: 'июл',
            August: 'авг',
            September: 'сен',
            October: 'окт',
            November: 'ноя',
            December: 'дек',
        },
    },
    week: {
        long: {
            self: 'Неделя',
            monday: 'понедельник',
            tuesday: 'вторник',
            wednesday: 'среда',
            thursday: 'четверг',
            friday: 'пятница',
            saturday: 'суббота',
            sunday: 'воскресенье',
        },
        short: {
            self: 'Неделя',
            monday: 'Пн',
            tuesday: 'Вт',
            wednesday: 'Ср',
            thursday: 'Чт',
            friday: 'Пт',
            saturday: 'Сб',
            sunday: 'Вс',
        },
    },
};
export default {
    locale: 'ru-RU',
    dayjsLocale: 'ru',
    Calendar: Calendar,
    DatePicker: {
        Calendar: Calendar,
        placeholder: {
            date: 'Пожалуйста, выберите дату',
            week: 'Пожалуйста, выберите неделю',
            month: 'Выберите месяц',
            year: 'Пожалуйста, выберите год',
            quarter: 'Выберите квартал',
        },
        placeholders: {
            date: ['Дата начала', 'Дата окончания'],
            week: ['начальная неделя', 'конец недели'],
            month: ['месяц начала', 'конец месяца'],
            year: ['год начала', 'конец года'],
            quarter: ['стартовая четверть', 'конец квартала'],
        },
        selectTime: 'период отбора',
        selectDate: 'выберите дату',
        today: 'Cегодня',
        now: 'В настоящее время',
        ok: 'OK',
    },
    Drawer: {
        okText: 'OK',
        cancelText: 'Отмена',
    },
    Empty: {
        noData: 'нет данных',
    },
    Modal: {
        okText: 'OK',
        cancelText: 'Отмена',
    },
    Pagination: {
        goto: 'Перейти',
        page: 'Страница',
        countPerPage: '/ стр.',
        total: 'Всего {0}',
        prev: 'Назад',
        next: 'Вперед',
        currentPage: 'страница {0}',
        prevSomePages: 'Предыдущие {0}',
        nextSomePages: 'Следующие {0}',
        pageSize: 'номер страницы',
    },
    Popconfirm: {
        okText: 'OK',
        cancelText: 'Отмена',
    },
    Table: {
        okText: 'OK',
        resetText: 'перезагрузить',
        sortAscend: 'Нажмите в порядке возрастания',
        sortDescend: 'Нажмите в порядке убывания',
        cancelSort: 'несортировать',
    },
    TimePicker: {
        ok: 'OK',
        placeholder: 'период отбора',
        placeholders: ['Время начала', 'Время окончания'],
        now: 'В настоящее время',
    },
    Progress: {
        success: 'успех',
        error: 'неудача',
    },
    Upload: {
        start: 'Начало',
        cancel: 'Отмена',
        delete: 'Удалить',
        reupload: 'Нажмите, чтобы повторить попытку',
        upload: 'Нажмите, чтобы загрузить',
        preview: 'предварительный просмотр',
        drag: 'Нажмите или перетащите файлы, чтобы загрузить их сюда',
        dragHover: 'Освободите файл и начните загрузку',
        error: 'Загрузка не удалась',
    },
    Typography: {
        copy: 'копировать',
        copied: 'скопировано',
        edit: 'редактировать',
        fold: 'складывать',
        unfold: 'расширять',
    },
    Transfer: {
        resetText: 'перезагрузить',
    },
    ImagePreview: {
        fullScreen: 'полноэкранный',
        rotateRight: 'повернуть вправо',
        rotateLeft: 'повернуть влево',
        zoomIn: 'увеличить',
        zoomOut: 'уменьшить',
        originalSize: 'оригинальный размер',
    },
};
