import 'dayjs/locale/zh-hk';
declare const _default: {
    locale: string;
    dayjsLocale: string;
    Calendar: {
        formatYear: string;
        formatMonth: string;
        monthBeforeYear: boolean;
        yearFormat: string;
        monthFormat: string;
        today: string;
        view: {
            month: string;
            year: string;
            week: string;
            day: string;
        };
        month: {
            long: {
                January: string;
                February: string;
                March: string;
                April: string;
                May: string;
                June: string;
                July: string;
                August: string;
                September: string;
                October: string;
                November: string;
                December: string;
            };
            short: {
                January: string;
                February: string;
                March: string;
                April: string;
                May: string;
                June: string;
                July: string;
                August: string;
                September: string;
                October: string;
                November: string;
                December: string;
            };
        };
        week: {
            long: {
                self: string;
                monday: string;
                tuesday: string;
                wednesday: string;
                thursday: string;
                friday: string;
                saturday: string;
                sunday: string;
            };
            short: {
                self: string;
                monday: string;
                tuesday: string;
                wednesday: string;
                thursday: string;
                friday: string;
                saturday: string;
                sunday: string;
            };
        };
    };
    DatePicker: {
        Calendar: {
            formatYear: string;
            formatMonth: string;
            monthBeforeYear: boolean;
            yearFormat: string;
            monthFormat: string;
            today: string;
            view: {
                month: string;
                year: string;
                week: string;
                day: string;
            };
            month: {
                long: {
                    January: string;
                    February: string;
                    March: string;
                    April: string;
                    May: string;
                    June: string;
                    July: string;
                    August: string;
                    September: string;
                    October: string;
                    November: string;
                    December: string;
                };
                short: {
                    January: string;
                    February: string;
                    March: string;
                    April: string;
                    May: string;
                    June: string;
                    July: string;
                    August: string;
                    September: string;
                    October: string;
                    November: string;
                    December: string;
                };
            };
            week: {
                long: {
                    self: string;
                    monday: string;
                    tuesday: string;
                    wednesday: string;
                    thursday: string;
                    friday: string;
                    saturday: string;
                    sunday: string;
                };
                short: {
                    self: string;
                    monday: string;
                    tuesday: string;
                    wednesday: string;
                    thursday: string;
                    friday: string;
                    saturday: string;
                    sunday: string;
                };
            };
        };
        placeholder: {
            date: string;
            week: string;
            month: string;
            year: string;
            quarter: string;
        };
        placeholders: {
            date: string[];
            week: string[];
            month: string[];
            year: string[];
            quarter: string[];
        };
        selectTime: string;
        selectDate: string;
        today: string;
        now: string;
        ok: string;
    };
    Drawer: {
        okText: string;
        cancelText: string;
    };
    Empty: {
        noData: string;
    };
    Modal: {
        okText: string;
        cancelText: string;
    };
    Pagination: {
        goto: string;
        page: string;
        countPerPage: string;
        total: string;
        prev: string;
        next: string;
        currentPage: string;
        prevSomePages: string;
        nextSomePages: string;
        pageSize: string;
    };
    Popconfirm: {
        okText: string;
        cancelText: string;
    };
    Table: {
        okText: string;
        resetText: string;
        sortAscend: string;
        sortDescend: string;
        cancelSort: string;
    };
    TimePicker: {
        ok: string;
        placeholder: string;
        placeholders: string[];
        now: string;
    };
    Progress: {
        success: string;
        error: string;
    };
    Upload: {
        start: string;
        cancel: string;
        delete: string;
        reupload: string;
        upload: string;
        preview: string;
        drag: string;
        dragHover: string;
        error: string;
    };
    Typography: {
        copy: string;
        copied: string;
        edit: string;
        fold: string;
        unfold: string;
    };
    Transfer: {
        resetText: string;
    };
    ImagePreview: {
        fullScreen: string;
        rotateRight: string;
        rotateLeft: string;
        zoomIn: string;
        zoomOut: string;
        originalSize: string;
    };
    Form: {
        validateMessages: {
            required: string;
            type: {
                string: string;
                number: string;
                boolean: string;
                array: string;
                object: string;
                url: string;
                email: string;
                ip: string;
            };
            number: {
                min: string;
                max: string;
                equal: string;
                range: string;
                positive: string;
                negative: string;
            };
            array: {
                length: string;
                minLength: string;
                maxLength: string;
                includes: string;
                deepEqual: string;
                empty: string;
            };
            string: {
                minLength: string;
                maxLength: string;
                length: string;
                match: string;
                uppercase: string;
                lowercase: string;
            };
            object: {
                deepEqual: string;
                hasKeys: string;
                empty: string;
            };
            boolean: {
                true: string;
                false: string;
            };
        };
    };
    ColorPicker: {
        history: string;
        preset: string;
        empty: string;
        singleColor: string;
        gradientColor: string;
    };
};
export default _default;
